package ch.epfl.tpp.sol;

public final class Point {
    private final double x, y;

    public Point(double x, double y) {
        this.x = x;
        this.y = y;
    }

    public double x() {
        return x;
    }

    public double y() {
        return y;
    }

    public Point translated(double dX, double dY) {
        return new Point(x + dX, y + dY);
    }
    
    @Override
    public boolean equals(Object that) {
        return that instanceof Point
                && x == ((Point)that).x()
                && y == ((Point)that).y();
    }
    
    @Override
    public int hashCode() {
        long xL = Double.doubleToLongBits(x);
        long yL = Double.doubleToLongBits(y);
        return (int)((xL ^ (xL >>> 32)) * 31 + (yL ^ (yL >>> 32)));
    }
    
    @Override
    public String toString() {
        return "("+ x +";"+ y +")";
    }
}
