package ch.epfl.tpp.sol.image;

import ch.epfl.tpp.sol.Color;
import ch.epfl.tpp.sol.Point;

public final class FramedImage extends AbstractImage {
    private final Image imageToFrame;
    private final double frameSize;
    private final Color frameColor;
    
    public FramedImage(Image imageToFrame, double frameSize, Color frameColor) {
        this.imageToFrame = imageToFrame;
        this.frameSize = frameSize;
        this.frameColor = frameColor;
    }

    @Override
    public double width() {
        return imageToFrame.width() + 2 * frameSize;
    }

    @Override
    public double height() {
        return imageToFrame.height() + 2 * frameSize;
    }

    @Override
    public Color colorAtPoint(Point p) {
        checkContainedPoint(p);
        Point p1 = p.translated(-frameSize, -frameSize);
        return imageToFrame.containsPoint(p1) ? imageToFrame.colorAtPoint(p1) : frameColor;
    }
}
